#include <window.h>
#include <unistd.h>

int i, blue, red, green, gray[100];

//----------------------------------------------------------------------------
// 	simple main
//----------------------------------------------------------------------------

main_window *mw;
main_window *popup; 
window	    *child;

/*----------------------------------------------------------------------------*
 *	matrix_window() 
 *	  - for displaying matrix activity
 *----------------------------------------------------------------------------*/
class matrix_window : public pixmap_window{

  int 	x, y;

public:
  	matrix_window(window &parent, int w, int h, int x, int y, int bw);

  	~matrix_window();
  virtual void 	draw_interior();
};

matrix_window *matw;

matrix_window::matrix_window(window &p, int w, int h, int x, int y, int bw)
: pixmap_window(p,w,h,x,y,bw) {
  ;
}

matrix_window::~matrix_window(){
  XFreePixmap(display,pix);
}

void matrix_window::draw_interior() {

  int i, xgran, ygran;
  printf("matrix_window::draw_interior()\n");

  xgran = width/10;
  ygran = height/10;

  for (i=0; i<100; ++i)
  {
        set_color(gray[i]); // sets gc_copy 
        XFillRectangle(display,pix,gc_copy,i%10*xgran,i/10*ygran,xgran,ygran);
  }
  set_color(red);
  DrawString(20,20,"Greetings : matrix window");
  set_color(black);
}


/*----------------------------------------------------------------------------*
 *	callback() 
 *	  - for button
 *----------------------------------------------------------------------------*/
void callback() {

  int i, xgran, ygran;

  xgran = child->width/10;
  ygran = child->height/10;

  for (i=0; i<100; ++i)
  {
        set_color(gray[i]); // sets gc_copy 
        XFillRectangle(display,child->Win,gc_copy,
		i%10*xgran,i/10*ygran,xgran,ygran);
  }
  
  matw->redraw();
  
  printf("Callback~\n"); 
}

void dispval() {
  printf("Scrollbar: %lf\n");
}

// scroll bar
scrollbar *scbr;
void sbinf() { printf(" %g",scbr->value); fflush(stdout); };

/*----------------------------------------------------------------------------*
 *	main() 
 *
 *	  - main driver
 *----------------------------------------------------------------------------*/
void main (int argc, char *argv[])
{


  mw = new main_window(argv[0],800,800); // xsize, ysize
  new text_win(*mw,"Hello World !", 0,0,10,10); // xsize, ysize, xloc, yloc
  new quit_button(*mw,100,30,400,0); // xsize, ysize, xloc, yloc

  blue  = alloc_named_color("blue");
  red   = alloc_named_color("red");
  green = alloc_named_color("green");
  printf("r=%d, g=%d, b=%d\n",red,green,blue);

  for (i=0; i<100; ++i) {
	int s = i*0xffff/100;
	gray[i] = alloc_color(s,s,s);
  }

  // main popup window
  popup = new main_window("popup", 200, 100);
	// within the popup window
  	// popup->CB_info = True;	// enable debugging
  	new button(*popup, "hello", 100, 20, 0, 0);
	// unmap --> kill window
  	new unmap_button(*popup, "delete",100, 20, 100, 0);

  // add popup button to main window
  new popup_button(*mw, popup, "popup", 100, 20, 0, 30);

  // add child window
  child = new window(*mw,  300, 300, 0, 100);
  char *text1[] = {"this is context sensitive","Help-Text",""
                   "which is bound to button ",0};
  new button(*child, "button", text1, 50, 20, 10, 10);
  // a button with callback-function
  button *sb = new callback_button(*child, "cb-info", callback, 50,20,10, 40);
  // sb->CB_info = TRUE; // debug inform about all events

  new window(*mw, 60, 60, 110, 0); // user-defined window
  double f;
  // w, h, x, y
  scbr = new scrollbar(*mw,&sbinf,200,30,0,400,0.0,100.0,30.0,"x = %.0lf");

  // user defined window
  window *child2 = new window(*mw,  300, 300, 0, 430);
  matw = new matrix_window(*child2,300,300,0,0,0);  

  mw->main_loop();
}

