//----------------------------------------------------------------------------
// 
//	file: slissom2-2.cc
// 
//	function: 2 interacting cortical layers 
//		  and a single retina 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Sat Dec 26 23:11:52 CST 1998
// 
//	$Revision: 1.11 $ $Date: 1999/03/30 12:46:28 $
//	$Log: slissom2-2.cc,v $
//	Revision 1.11  1999/03/30 12:46:28  yschoe
//	1. spikelayer3 class can be used instead (optional)
//	2. orientation map display in GUI window
//	3. neuron stat plot while trainig/testing
//	4. hsv_spike_flag , uniform_wgt_flag, input_delay added
//	5. LAMBDA_SYN and LAMBDA_INH overridden by synapse_decay and inhloop_decay
//	6. call_resize_lat_inh_rad added
//	7. uniform_wgt_flag\\
//
//
//
//
//	8. weight display made more versatile
//
//	Revision 1.10  1999/03/05 11:04:23  yschoe
//	added synapse_decay and inhloop_decay to config file
//
//	Revision 1.9  1999/02/25 09:17:01  yschoe
//	added on-line muaplot capability
//
//	Revision 1.8  1999/02/09 07:56:44  yschoe
//	added call_kill_lat_weights() commands to parser interface
//
//	Revision 1.7  1999/02/08 08:04:40  yschoe
//	*** empty log message ***
//
//	Revision 1.6  1999/02/06 05:09:13  yschoe
//	added input spec list stuff.
//
//	Revision 1.5  1999/02/04 22:11:30  yschoe
//	removed COG calculation and made it refer to the same routine in netlayer
//	class.
//
//	Revision 1.4  1999/01/10 04:15:02  yschoe
//	1. added CF_RAD and CF_RAD2 for inter area RF size
//	2. separator between or map output changed to series of numbers for
//	easier plotting later.
//
//	Revision 1.3  1999/01/07 09:48:26  yschoe
//	save both maps at the end of training
//
//	Revision 1.2  1999/01/07 09:39:49  yschoe
//	1. added or pref calculation
//	2. command line loading of both map images
//
//	Revision 1.1  1998/12/31 08:03:30  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: slissom2.cc
// 
//	function: modify slissom algorithm to be more robust to parameters 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Mon Nov 30 22:45:30 CST 1998
// 
//	$Revision: 1.11 $ $Date: 1999/03/30 12:46:28 $
//	$Log: slissom2-2.cc,v $
//	Revision 1.11  1999/03/30 12:46:28  yschoe
//	1. spikelayer3 class can be used instead (optional)
//	2. orientation map display in GUI window
//	3. neuron stat plot while trainig/testing
//	4. hsv_spike_flag , uniform_wgt_flag, input_delay added
//	5. LAMBDA_SYN and LAMBDA_INH overridden by synapse_decay and inhloop_decay
//	6. call_resize_lat_inh_rad added
//	7. uniform_wgt_flag\\
//
//
//
//
//	8. weight display made more versatile
//
//	Revision 1.10  1999/03/05 11:04:23  yschoe
//	added synapse_decay and inhloop_decay to config file
//
//	Revision 1.9  1999/02/25 09:17:01  yschoe
//	added on-line muaplot capability
//
//	Revision 1.8  1999/02/09 07:56:44  yschoe
//	added call_kill_lat_weights() commands to parser interface
//
//	Revision 1.7  1999/02/08 08:04:40  yschoe
//	*** empty log message ***
//
//	Revision 1.6  1999/02/06 05:09:13  yschoe
//	added input spec list stuff.
//
//	Revision 1.5  1999/02/04 22:11:30  yschoe
//	removed COG calculation and made it refer to the same routine in netlayer
//	class.
//
//	Revision 1.4  1999/01/10 04:15:02  yschoe
//	1. added CF_RAD and CF_RAD2 for inter area RF size
//	2. separator between or map output changed to series of numbers for
//	easier plotting later.
//
//	Revision 1.3  1999/01/07 09:48:26  yschoe
//	save both maps at the end of training
//
//	Revision 1.2  1999/01/07 09:39:49  yschoe
//	1. added or pref calculation
//	2. command line loading of both map images
//
//	Revision 1.1  1998/12/31 08:03:30  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: slissom.cc
// 
//	function: test spikelayer2 class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Sun Sep 27 05:49:27 CDT 1998
// 
//	Revision: 1.6  Date: 1998/11/09 13:23:42 
//	Log: slissom.cc,v 
//	Revision 1.6  1998/11/09 13:23:42  yschoe
//	*** empty log message ***
//
//	Revision 1.5  1998/10/26 04:02:22  yschoe
//	1. weight display windows added
//	2. network weight setup parameters added to blackboard for easier
//	   customization with the conf file
//	3. filename handling got better by the use of filename class.
//	4. simulation environment and network image separated.
//	5. command hooks used with the simulation environment.
//
//	Revision 1.4  1998/10/18 06:14:58  yschoe
//	*** empty log message ***
//
//	Revision 1.3  1998/10/16 10:35:21  yschoe
//	added randomness, and added a couple of display windows.
//
//	Revision 1.2  1998/10/05 19:59:23  yschoe
//	now capable of  gaussian initial weights.
//
//	Revision 1.1  1998/10/02 09:24:16  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: lissom.cc
// 
//	function: defines and implements LISSOM 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Wed Aug  5 18:04:55 CDT 1998
// 
//	Revision: 1.15 Date: 1998/09/14 06:03:04 
//	Log: lissom.cc,v -- see rlog
//
//----------------------------------------------------------------------------

%module slissom2_2

%{ 	// Includes

#include <iostream.h>
#include <signal.h>
#ifdef VERSION3
#include <nnview/spikelayer3.h>
#else
#include <nnview/spikelayer2.h>
#endif
#include <nnview/simulog.h>
#include <nnview/real.h>
#include <nnview/coord.h>
#include <nnview/geninput.h>
#include <nnview/simenv.h>
#include <nnview/filename.h>
#include <nnview/inputlist.h>
#include <nnview/matrix.h>

#ifndef LissomCUI
#include <window.h>
#include <nnview/plot_window.h>
#include <nnview/matrix_window.h>
#include <nnview/tool_window.h>
#include <nnview/net_window.h>
#include <nnview/disputil_window.h>
#include <nnview/gdb_visualize.h>
#include <nnview/affw_window.h>
#include <nnview/latw_window.h>
#include <nnview/simstat.h>
#endif

#ifdef VERSION3
#define spikelayer2 spikelayer3
#endif
%}

//----------------------------------------------------------------------------
// Network topology and simulation parameters
simenv	*environment;
#ifndef LissomCUI
simstat *stats;
simstat *stats2;
#endif
int 	N = 11;
int 	M = 11;
int 	INH_RAD = 11;
int 	EXC_RAD = 7;
int 	RF_RAD = 9;
int 	CF_RAD = 1;

int	N2 = 11;
int	M2 = 11;
int	INH_RAD2 = 11;
int	EXC_RAD2 = 7;
int	RF_RAD2 = 8;
int 	CF_RAD2 = 1;

int 	GRAN = 5;
int 	WGT_GRAN = 2;
REAL 	LAMBDA_SYN = 0.3;
REAL 	LAMBDA_INH = 0.1;
REAL 	randomness=1.0;
REAL 	aff_setup_decay=0.5;
REAL 	lat_inh_setup_decay=1.0;
REAL 	lat_exc_setup_decay=3.0;
REAL 	sigmax=1.0;
REAL 	sigmay=1.0;
REAL 	wgt_disp_scale=1.0;
int 	disp_rate = 1;
int 	wgt_disp_rate = 1000;
int 	iters = 0;
int 	iters_per_run = 10;
int 	tsettle = 9;
int 	test_flag = 0;
char 	conffilename[100]; // config file base name
char 	buffname[100]; // config file base name
int     save_rate = 5000;
int     wgt_disp_flag = 0;
int	instar_norm = 0;
REAL	scaleup=1.0;
int	hsv_spike_flag=0;
int	uniform_wgt_flag=0;
int	cur_x, cur_y; // training input location

REAL	synapse_decay = 0.4;
REAL	inhloop_decay = 0.5;
REAL	synapse_decay2 = 0.4;
REAL	inhloop_decay2 = 0.5;

int	input_delay = 1;

int     steps;
int 	t=0;
simulog	*netlog;

netlayer	*input;
spikelayer2	*map;
spikelayer2	*map2;

coord		**ideal;

geninput	*input_generator; // input generator class
inputlist	*input_spec_list; 	  // list of input specs

matrix<REAL>	*map1_or;
matrix<REAL>	*map2_or;

// End : network topology and simulation environment stuff
//----------------------------------------------------------------------------

// Matrices for displaying
REAL		**spikeact;
REAL		**spikeact2;

void tcl_run();
void tcl_setup(char *cmdstr, char *configfile);
void tcl_list_variables();
void tcl_setup_input(int i);
void tcl_settle_one_iter(int i, int k);
void tcl_learn_and_normalize(int i);
void tcl_clear_activity();
void tcl_run_hooks_after(int i);
void tcl_log_and_save_cog_and_weights(int i);
void tcl_command();
