#!/usr/bin/perl

if ($#ARGV != 1) {

  print "usage: avg-dat.pl <rate> <window_size>\n";
  exit;

}

$rate = $ARGV[0];
$window_size = $ARGV[1];

$avg = 0.0;

$true_sum = 0;
$i=0;

#----------------------------------------
# setup window array
#----------------------------------------
@window = ();
for ($i=0; $i<$window_size; ++$i) {
	push(@window,0.0);
}

#----------------------------------------
# read data and average
#----------------------------------------
$err_sum=0;
while (<STDIN>) {

  #--------------------
  # get data
  #--------------------
  chop;
  $dat = $_;

  #--------------------
  # true average
  #--------------------
  $true_sum += $dat;
  $true_avg = $true_sum/($i+1);

  #--------------------
  # windowed average
  #--------------------
  shift(@window); push(@window,$dat);
  $win_avg = &average_window(\@window)/($#window+1);

  #--------------------
  # running average
  #--------------------
  $avg = $avg * $rate + $dat*(1.0-$rate);

  #--------------------
  # windowed average
  #--------------------
  $err = $win_avg - $avg;

  print "$i $avg $true_avg $win_avg $err\n";
  $err_sum += abs($err);

  $i++;

}

$err_avg = $err_sum/$i;
print stderr "Abslute error average = $err_avg\n";

sub average_window {

  my ($aref) = @_;
  my $i=0;
  my $sum=0;

  for ($i=0; $i<=$#$aref; ++$i) {
	$sum += $$aref[$i];
  }
  return $sum;
}
		

