# function [f,g,vf,vg,l1,l2] = fracgaus2(n,exponent,div)
#	returns f and g with same variance

function [nf,ng,vnf,vng,l1,l2] = fracgaus2(x,e,d)

	f = 1./(x.^e);
	nf = f/sum(f);

	vnf = sum((x.^2).*nf)/length(nf);

	g = normal_pdf(x,0,vnf);
	ng = g/sum(g)/d;

	vng = sum((x.^2).*ng)/length(ng);

	df = diff(sign(nf-ng));

	[mx,l2ix]=max(df);
	[mn,l1ix]=min(df);

	l1 = x(l1ix);
	l2 = x(l2ix);

endfunction

