# d = gausoverlap(n,phi,delta,theta)
# 	In an n x n matrix, for a given pair of gaussian bars (Receptive fields)
#	with the configuration phi,delta,theta, find the dotproduct
#	of this matrix and a separate matrix that has a long gaussian
#	passing through the two RF bars.
#	d is a measure of how these two RFs may interact.

function [d,rf,input] = gausoverlap(n,phi,delta,theta)

	sx = round(n/2);
	sy = round(n/2);
	src = gaussian(n,n,round(n/10),round(n/30),sx,sy,0);
	
 	tx = n-round(delta*sin(phi*pi/180.0))-sx;
	ty = round(delta*cos(phi*pi/180.0))+sy;
	target = gaussian(n,n, round(n/10),round(n/30), tx, ty,theta);

	rf = max(src,target);
	# rf = src+target;

	input = gaussian(n,n,round(n/5),round(n/30),
			round((sx+tx)/2),round((sy+ty)/2),
			phi);

	d = vec(rf)'*vec(input);

endfunction
