## usage: [Kmax1] = circaperturesigma(Kmax)
##
##	Kmax=absolute spatial frequency preference matrix
##     
##
##      Finds the circular aperture for the specified Kmax file
##     
##     By Subramonia Sarma <sps8556@cs.tamu.edu> on June 3 2002

function [Kmax1] = circaperturesigma(Kmax)
      
         # get size of matrix
	[rows, cols] = size(Kmax);

        
        printf("cols = %d , rows = %d\n",cols,rows);
        

	Kmax1 = zeros(rows,cols);   	
	
	xc=ceil(rows/2);
	yc=ceil(cols/2);

        printf("xc = %d , yc = %d\n",xc,yc);

	if (rows < cols)
	r=rows/2
	else
	r=cols/2;
	endif

	for i=1:rows
	for j=1:cols
	
        if (((abs(i-xc)**2)+(abs(j-yc)**2)) > (r**2))
	Kmax1(i,j)=-1;
	else
	Kmax1(i,j)=Kmax(i,j);
	endif
	endfor
        endfor
            
	#save -ascii img1 nV;	

 
 endfunction

