#!/usr/bin/perl

$usage = <<EOF ;

usage: procavgcorrel.pl <experiment1-auto> <experiment1-cross> ....

	2*n input files can be specified.
	2 files as a pair will be plotted against the same x value.
	y value will be the average, with error bars being variance.
	
EOF

my @avg, @var;

for ($i=0 ; $i<=$#ARGV; ++$i) {

  ($avg[$i],$var[$i]) = split(/:/,&mean_and_var($ARGV[$i]),2);

  if ($i%2==1) {
	$idx = int($i/2);
	print "$idx ".$avg[$i-1]." ".$var[$i-1]." ".$avg[$i]." ".$var[$i]."\n";
  }

}

sub mean_and_var {

  my ($filename) = @_;

  open(FP,$filename);
 

  my $sum,$count,@val;
  $sum = 0;
  $count = 0;

  while (<FP>) {
	chop;
	my $idx;
	($idx,$val[$count]) = split(/[\s]+/); 
	$sum += $val[$count];
	$count++;
  }
  close(FP);

  my $avg,$var,$j;
  $avg = $sum/$count;
  
  $var = 0;
  for($j=0; $j<$count; ++$j) {
	$var += ($val[$j]-$avg)**2;
  }
  $var /= ($count-1);

  return "$avg:$var";
}
  
