#!/usr/bin/perl

# process (freq,theta,d) statistics dump from the command
# dump_wgt_or_stat in slissom.
#	Blank out every other track. Just simply multiply rho by 2.

$distance_binsize = 5;

if ($#ARGV != 3) {

	print "usage: prowgtstat.pl -freq|-freqpolar|-prob|-max|-sum|-maxpolar|-probpolar|-sumpolar <size> <thresh> <or_stat_dump_filename>\n";
	print "		-max is the default \n";
	print <<EOF;
	-freq : print the most probable freq -- 2d matrix
	-freqpolar : print the most probable freq -- polar coordinate
	-prob  : print the probability -- 2d matrix
	-max   : prob of most probable freq -- 2d matrix
	-sum	: sum?
	-maxpolar : prob of most probable freq -- polar coordinate
	-probpolar : prob of most probable freq -- polar coordinate
	-sumpolar : ??
	<size> : only used for 2d matrix -- resulting size
EOF

	exit;

}

$freq_output_flag = ($ARGV[0] eq "-freq")?1:0;
$freq_polar_output_flag = ($ARGV[0] eq "-freqpolar")?1:0;
$max_output_flag = ($ARGV[0] eq "-max")?1:0;
$max_polar_output_flag = ($ARGV[0] eq "-maxpolar")?1:0;
$sum_output_flag = ($ARGV[0] eq "-sum")?1:0;
$prob_polar_output_flag = ($ARGV[0] eq "-probpolar")?1:0;
$sum_polar_output_flag = ($ARGV[0] eq "-sumpolar")?1:0;

# init matrix
$N = $ARGV[1];
for ($i=0; $i<$N; ++$i) {
	for ($j=0; $j<$N; ++$j) {
		$matrix[$i][$j] = 0;
	}
}

$thresh = $ARGV[2];

# load file and proces
open(FP,"$ARGV[3]");

$sum = 0.0;
$alternate_zero_degree = 0;
$alternate_count = 0;
$max_d = 0;
while(<FP>) {
	chop;
	# Get stat
	($d,$theta,$freq) = split(/\ /,$_);
	$freq = int($freq);
	$theta = int($theta);
	$d= int($d);

	$d = int($d/$distance_binsize);

	if ($d>$max_d) { $max_d = $d; }

	# Fix side effect of only having 0 to 170 degree
	if (0) {
		if ($alternate_count%2==0) {
			$theta = 180;
		} 
		$alternate_count ++;
	}


	# update freq,d,theta count
	$theta_d{"$freq $d $theta"} ++;
	$theta_d_sum{"$d $theta"} ++;
	$sum ++;
	$sum_prob{"$d $theta"} ++;
	
	# update max prob freq (freq that has the maximum count)
	if (exists($max_prob_freq{"$d $theta"})) {
		$max_freq = $max_prob_freq{"$d $theta"};
	} else {
		$max_freq = 0;
	}
	if ($theta_d{"$freq $d $theta"}>=$theta_d{"$max_freq $d $theta"}) {
		$max_prob_freq{"$d $theta"} = $freq;
		$max_prob{"$d $theta"} = $theta_d{"$freq $d $theta"};
	}
       

	# $sum_prob{"$freq $d"} += $freq_d{"$freq $d $theta"};


	# Dirty hack : rotate 180 and add that too.

	$theta = ($theta+180)%360;

	# update freq,d,theta count
	$theta_d{"$freq $d $theta"} ++;
	$theta_d_sum{"$d $theta"} ++;
	$sum ++;
	$sum_prob{"$d $theta"} ++;
	
	# update max prob freq (freq that has the maximum count)
	if (exists($max_prob_freq{"$d $theta"})) {
		$max_freq = $max_prob_freq{"$d $theta"};
	} else {
		$max_freq = 0;
	}
	if ($theta_d{"$freq $d $theta"}>=$theta_d{"$max_freq $d $theta"}) {
		$max_prob_freq{"$d $theta"} = $freq;
		$max_prob{"$d $theta"} = $theta_d{"$freq $d $theta"};
	}
	# $sum_prob{"$freq $d"} += $freq_d{"$freq $d $theta"};
        

	$theta = ($theta+180)%360;
}
close(FP);

print STDERR "ALT_COUNT (0 vs 180) = $alternate_count\n";

$thetadsum = 0.0;
foreach $key (keys(%sum_prob)) {
	$thetadsum += $sum_prob{$key};
}
print STDERR " SUM = $sum \n";
print STDERR " Sigma_{freq} Sigma_{d} Sigma_{theta} = $thetadsum \n";
  

if ($max_output_flag) {
	foreach $key (keys(%max_prob_freq)) {
	        #$max_prob_freq{$key}=int($max_prob_freq{$key});
		print "$max_prob_freq{$key} $key\n";
	}
	exit;
}


# print result in a NxN matrix
$half_N = int($N/2);

$prob_sum = 0.0;
$min_prob = 999;
foreach $key (keys(%max_prob_freq)) {
	($d,$theta) = split(/\ /,$key);

  	if ($max_polar_output_flag) {
	                #$max_prob{"$d $theta"}=int($max_prob{"$d $theta"});
			print $max_prob{"$d $theta"}." $d $theta"."\n";
	} elsif ($prob_polar_output_flag) {
			$prob = $sum_prob{"$d $theta"}/($sum*1.0);
			if ($prob<$min_prob) { $min_prob = $prob; }
			$prob_sum += $prob;
			print "$theta $d $prob\n";
	} elsif ($sum_polar_output_flag) {
			$prob = $sum_prob{"$d $theta"};
			$prob_sum += $prob;
			print "$theta $d $prob\n";
	} elsif ($freq_polar_output_flag) {
                        
	                #$max_prob_freq{$key}=int($max_prob_freq{$key});
			$freq = $max_prob_freq{$key};
			#$or_val = 1.0-$freq/180.0;
                        #$or_val = 1.0-$freq/360.0;
			$or_val = $freq;
                        print "$or_val $d $theta\n";
	                #print "$freq $d $theta\n";
        } else {
		# For cartesian matrix output
		$t = 3.141592*$theta/180.0;
		$x = int($d*cos($t)+0.5)+$half_N;
		$y = int($d*sin($t)+0.5)+$half_N;
                $max_prob_freq{$key}=int($max_prob_freq{$key});
		$freq = $max_prob_freq{$key};
		if ($max_prob{"$d $theta"}>$thresh) {
			if ($freq_output_flag || $freq_polar_output_flag) {
				$matrix[$x][$y] = $freq;
				
			} elsif ($sum_output_flag) {
				$matrix[$x][$y] = $sum_prob{"$d $theta"};
			} else {
				$matrix[$x][$y] = $max_prob{"$d $theta"};
			}
		}
	}
} 

# fill in ------ disabled
if (0) {
if ($prob_polar_output_flag) {
	for ($i=0; $i<360; $i++) {
		for ($d=0; $d<=$max_d; ++$d) {
			if(!exists($max_prob_freq{"$d $theta"})) {
				print "$i $d $min_prob\n";
			}
		}
	}
}	
}
		
		

print STDERR "RECOUNTED_SUM = $prob_sum \n";

if ($max_polar_output_flag || $prob_polar_output_flag || $sum_polar_output_flag || $freq_polar_output_flag ) {
	exit;
}

for ($j=0; $j<$N; ++$j) {
	for ($i=0; $i<$N; ++$i) {
		print $matrix[$i][$j]." ";
	}
	print "\n";
}

