#!/usr/bin/perl

$usage = <<EOF;
usage: texfig.pl <n> <name>
	<n> : number of sub-figures
	<name> : name of figure
EOF

if ($#ARGV != 1) {
	print $usage;
	exit;
}

$n = $ARGV[0];
$name = $ARGV[1];

$fig = &subfigpic($n);

print <<EOF;
\\begin{figure}
\\centerline{
	$fig
}
\\vspace{0.07in}
\\titledcaption{$name}{}
{
}
\\end{figure}
EOF

sub subfigpic {
	my ($n) = @_;
	my $scale = 1/$n;
	my $i;
	my $str="";
	my %ref = ( 1, "a", 2, "b", 3, "c", 4, "d", 5, "e" );

	for ($i=1; $i<=$n; ++$i) {
	$str .= <<EOF;
	\\centerline{
	\\begin{minipage}{\\oneplotwidth}
	\\frame{\\pspic[\\pscolor]{\\oneplotwidth}{!}{file}}
	\\end{minipage}
	}
	\\centerline{(\$$ref{$i}\$)}
	\\vspace{0.05in}
%---- $ref{$i}
EOF
	}
	return $str;
}
