//----------------------------------------------------------------------------
// 
//	file: ppmgdbmat.cc
// 
//	function: plot gdbmatrix dump in ppm format
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Thu Nov 26 04:52:52 CST 1998
// 
//	$Revision: 1.1 $ $Date: 2002/06/20 22:35:52 $
//	$Log: ppmcolormap.cc,v $
//	Revision 1.1  2002/06/20 22:35:52  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#include <iostream.h>
#include <stdio.h>
#include <nnview/ppmio.h>
#include <nnview/matrix.h>
#include <nnview/filename.h>
#include <nnview/real.h>

//----------------------------------------------------------------------------
//	usage() 
//	  - prog usage
//----------------------------------------------------------------------------
void usage(int argc) {

  if (argc != 1) { 
    cout  << " usage: ppmcolormap" << endl;
    cout  << " 		- uses cartesian coordinate " << endl;
    exit(0);
  }

}

//----------------------------------------------------------------------------
//	main() 
//	  - the main
//----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

  usage(argc);
	
  FILE *fp;

  matrix<REAL> *ppm_buff= new matrix<REAL>(1,1);

  ppmio *io = new ppmio(ppm_buff->mat,1,1,256);

  io->ppmcolormap("rgbmap.dat",PPM_RGB);
  io->ppmcolormap("hsvmap.dat",PPM_HSV);
  io->ppmcolormap("graymap.dat",PPM_GRAY);

  delete io;
  delete ppm_buff;

}

