## Copyright (C) 2000 uschoe
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, write to the Free
## Software Foundation, 59 Temple Place - Suite 330, Boston, MA
## 02111-1307, USA.

## usage: randwalk(steps,n)
##
## Return a 2D matrix with randomwalk
##	steps : number of random walk steps
##	n : size of resulting matrix

## Author: Yoonsuck Choe <yschoe@cs.utexas.edu>

function M = randwalk(steps,n)
	xy = [ 0 0 ];
	
	for i=2:steps
		xy = [ xy ; xy(i-1,1)+rand()-0.5 xy(i-1,2)+rand()-0.5 ];
	endfor

	M=coordtograymat(xy,n);

endfunction
